<?php

require_once(dirname(__FILE__) . '/../init.php');

try
{
    // Define a url utilizada
    \gateway\ApiClient::setBaseUrl("https://sandbox.mundipaggone.com");

    // Define a chave da loja
    \gateway\ApiClient::setMerchantKey("85328786-8BA6-420F-9948-5352F5A183EB");

    // Cria objeto requisição
    $request = new \gateway\One\DataContract\Request\CreateSaleRequest();

    // Dados da transação de cartão de crédito
    $creditCardTransaction = new \gateway\One\DataContract\Request\CreateSaleRequestData\CreditCardTransaction();
    $request->addCreditCardTransaction($creditCardTransaction);
    $creditCardTransaction
    ->setAmountInCents(100)
    ->setInstallmentCount(1)
    ->setCreditCardOperation(\gateway\One\DataContract\Enum\CreditCardOperationEnum::AUTH_ONLY)
    ->setTransactionDateInMerchant(new DateTime())
    ->setTransactionReference(uniqid())
    ->getCreditCard()
    ->setCreditCardBrand(\gateway\One\DataContract\Enum\CreditCardBrandEnum::MASTERCARD)
    ->setCreditCardNumber("5555444433332222")
    ->setExpMonth(12)
    ->setExpYear(2030)
    ->setHolderName("gateway TESTE")
    ->setSecurityCode("999")
    ->getBillingAddress()
    ->setAddressType(\gateway\One\DataContract\Enum\AddressTypeEnum::BILLING)
    ->setStreet("Rua da Quitanda")
    ->setNumber("199")
    ->setComplement("10º andar")
    ->setDistrict("Centro")
    ->setCity("Rio de Janeiro")
    ->setState("RJ")
    ->setZipCode("20091005")
    ->setCountry(\gateway\One\DataContract\Enum\CountryEnum::BRAZIL);

    // Options do credit card transaction
    $creditCardTransaction->getOptions()
    ->setCurrencyIso(\gateway\One\DataContract\Enum\CurrencyIsoEnum::BRL)
    ->setCaptureDelayInMinutes(0)
    ->setIataAmountInCents(0)
    ->setInterestRate(0)
    ->setPaymentMethodCode(\gateway\One\DataContract\Enum\PaymentMethodEnum::SIMULATOR)
    ->setSoftDescriptorText("TESTE");

    // Recurrency do credit card transaction
    $creditCardTransaction->getRecurrency()
    ->setDateToStartBilling(new DateTime())
    ->setFrequency(\gateway\One\DataContract\Enum\FrequencyEnum::MONTHLY)
    ->setInterval(1)
    ->setRecurrences(2);

    // Dados do comprador
    $request->getBuyer()
    ->setName("Comprador Mundi")
    ->setPersonType(\gateway\One\DataContract\Enum\PersonTypeEnum::COMPANY)
    ->setBuyerReference("123456")
    ->setBuyerCategory(\gateway\One\DataContract\Enum\BuyerCategoryEnum::PLUS)
    ->setDocumentNumber("58828172000138")
    ->setDocumentType(\gateway\One\DataContract\Enum\DocumentTypeEnum::CNPJ)
    ->setEmail("comprador@gateway.com")
    ->setEmailType(\gateway\One\DataContract\Enum\EmailTypeEnum::COMERCIAL)
    ->setGender(\gateway\One\DataContract\Enum\GenderEnum::MALE)
    ->setHomePhone("(21)30030460")
    ->setMobilePhone("(21)999998888")
    ->setBirthDate(\DateTime::createFromFormat('d/m/Y', '11/05/1990'))
    ->setFacebookId("1234567890")
    ->setTwitterId("1234567890")
    ->setCreateDateInMerchant(new \DateTime())
    ->setLastBuyerUpdateInMerchant(new \DateTime())
    ->addAddress()
    ->setAddressType(\gateway\One\DataContract\Enum\AddressTypeEnum::COMMERCIAL)
    ->setStreet("Rua da Quitanda")
    ->setNumber("199")
    ->setComplement("10º andar")
    ->setDistrict("Centro")
    ->setCity("Rio de Janeiro")
    ->setState("RJ")
    ->setZipCode("20091005")
    ->setCountry(\gateway\One\DataContract\Enum\CountryEnum::BRAZIL);

    $request->getMerchant()
    ->setMerchantReference("gateway LOJA 1");

    $request->getOptions()
    ->disableAntiFraud()
    ->setAntiFraudServiceCode("123")
    ->setCurrencyIso(\gateway\One\DataContract\Enum\CurrencyIsoEnum::BRL)
    ->setRetries(3);

    $request->getOrder()
    ->setOrderReference(uniqid());

    $request->getRequestData()
    ->setEcommerceCategory(\gateway\One\DataContract\Enum\EcommerceCategoryEnum::B2B)
    ->setIpAddress("255.255.255.255")
    ->setOrigin("123")
    ->setSessionId(uniqid());

    // Carrinho de compras
    $shoppingCart = $request->addShoppingCart();
    $shoppingCart->setDeliveryDeadline(new DateTime());
    $shoppingCart->setEstimatedDeliveryDate(new DateTime());
    $shoppingCart->setFreightCostInCents(199);
    $shoppingCart->setShippingCompany("Correios");
    $shoppingCart->getDeliveryAddress()
    ->setAddressType(\gateway\One\DataContract\Enum\AddressTypeEnum::SHIPPING)
    ->setStreet("Rua da Quitanda")
    ->setNumber("199")
    ->setComplement("10º andar")
    ->setDistrict("Centro")
    ->setCity("Rio de Janeiro")
    ->setState("RJ")
    ->setZipCode("20091005")
    ->setCountry(\gateway\One\DataContract\Enum\CountryEnum::BRAZIL);

    $shoppingCart->addShoppingCartItem()
    ->setDescription("Apple iPhone 5s 16gb")
    ->setDiscountAmountInCents(160000)
    ->setItemReference("AI5S")
    ->setName("iPhone 5S")
    ->setQuantity(1)
    ->setUnitCostInCents(1800)
    ->setTotalCostInCents(1600);

    $shoppingCart->addShoppingCartItem()
    ->setDescription("TESTE")
    ->setDiscountAmountInCents(0)
    ->setItemReference("TESTE")
    ->setName("TESTE")
    ->setQuantity(2)
    ->setUnitCostInCents(1099)
    ->setTotalCostInCents(2198);

    //Cria um objeto ApiClient
    $client = new gateway\ApiClient();

    // Faz a chamada para criação
    $response = $client->createSale($request);

    // Imprime responsta
    print "<pre>";
    print json_encode(array('success' => $response->isSuccess(), 'data' => $response->getData()), JSON_PRETTY_PRINT);
    print "</pre>";
}
catch (\gateway\One\DataContract\Report\ApiError $error)
{
    // Imprime json
    print "<pre>";
    print json_encode($error, JSON_PRETTY_PRINT);
    print "</pre>";
}
catch (Exception $ex)
{
    // Imprime json
    print "<pre>";
    print json_encode($ex, JSON_PRETTY_PRINT);
    print "</pre>";
}